<?php
/**
* This class has been generated by TheliaStudio
* For more information, see https://github.com/thelia-modules/TheliaStudio
*/

namespace CanadaPost\Action\Base;

use CanadaPost\Model\Map\CanadaPostOrderTableMap;
use CanadaPost\Event\CanadaPostOrderEvent;
use CanadaPost\Event\CanadaPostOrderEvents;
use CanadaPost\Model\CanadaPostOrderQuery;
use CanadaPost\Model\CanadaPostOrder;
use Thelia\Action\BaseAction;
use Thelia\Core\Event\ToggleVisibilityEvent;
use Thelia\Core\Event\UpdatePositionEvent;
use Propel\Runtime\Propel;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Thelia\Core\Event\TheliaEvents;
use \Thelia\Core\Event\TheliaFormEvent;

/**
 * Class CanadaPostOrderAction
 * @package CanadaPost\Action
 * @author TheliaStudio
 */
class CanadaPostOrderAction extends BaseAction implements EventSubscriberInterface
{
    public function create(CanadaPostOrderEvent $event)
    {
        $this->createOrUpdate($event, new CanadaPostOrder());
    }

    public function update(CanadaPostOrderEvent $event)
    {
        $model = $this->getCanadaPostOrder($event);

        $this->createOrUpdate($event, $model);
    }

    public function delete(CanadaPostOrderEvent $event)
    {
        $this->getCanadaPostOrder($event)->delete();
    }

    protected function createOrUpdate(CanadaPostOrderEvent $event, CanadaPostOrder $model)
    {
        $con = Propel::getConnection(CanadaPostOrderTableMap::DATABASE_NAME);
        $con->beginTransaction();

        try {
            if (null !== $id = $event->getId()) {
                $model->setId($id);
            }

            if (null !== $addressId = $event->getAddressId()) {
                $model->setAddressId($addressId);
            }

            if (null !== $orderAddressId = $event->getOrderAddressId()) {
                $model->setOrderAddressId($orderAddressId);
            }

            if (null !== $serviceId = $event->getServiceId()) {
                $model->setServiceId($serviceId);
            }

            if (null !== $options = $event->getOptions()) {
                $model->setOptions($options);
            }

            $model->save($con);

            $con->commit();
        } catch (\Exception $e) {
            $con->rollback();

            throw $e;
        }

        $event->setCanadaPostOrder($model);
    }

    protected function getCanadaPostOrder(CanadaPostOrderEvent $event)
    {
        $model = CanadaPostOrderQuery::create()->findPk($event->getId());

        if (null === $model) {
            throw new \RuntimeException(sprintf(
                "The 'canada_post_order' id '%d' doesn't exist",
                $event->getId()
            ));
        }

        return $model;
    }

    public function beforeCreateFormBuild(TheliaFormEvent $event)
    {
    }

    public function beforeUpdateFormBuild(TheliaFormEvent $event)
    {
    }

    public function afterCreateFormBuild(TheliaFormEvent $event)
    {
    }

    public function afterUpdateFormBuild(TheliaFormEvent $event)
    {
    }

    /**
     * Returns an array of event names this subscriber wants to listen to.
     *
     * The array keys are event names and the value can be:
     *
     *  * The method name to call (priority defaults to 0)
     *  * An array composed of the method name to call and the priority
     *  * An array of arrays composed of the method names to call and respective
     *    priorities, or 0 if unset
     *
     * For instance:
     *
     *  * array('eventName' => 'methodName')
     *  * array('eventName' => array('methodName', $priority))
     *  * array('eventName' => array(array('methodName1', $priority), array('methodName2'))
     *
     * @return array The event names to listen to
     *
     * @api
     */
    public static function getSubscribedEvents()
    {
        return array(
            CanadaPostOrderEvents::CREATE => array("create", 128),
            CanadaPostOrderEvents::UPDATE => array("update", 128),
            CanadaPostOrderEvents::DELETE => array("delete", 128),
            TheliaEvents::FORM_BEFORE_BUILD . ".canada_post_order_create" => array("beforeCreateFormBuild", 128),
            TheliaEvents::FORM_BEFORE_BUILD . ".canada_post_order_update" => array("beforeUpdateFormBuild", 128),
            TheliaEvents::FORM_AFTER_BUILD . ".canada_post_order_create" => array("afterCreateFormBuild", 128),
            TheliaEvents::FORM_AFTER_BUILD . ".canada_post_order_update" => array("afterUpdateFormBuild", 128),
        );
    }
}
