<?php
/**
* This class has been generated by TheliaStudio
* For more information, see https://github.com/thelia-modules/TheliaStudio
*/

namespace CanadaPost\Action\Base;

use CanadaPost\Model\Map\CanadaPostServiceTableMap;
use CanadaPost\Event\CanadaPostServiceEvent;
use CanadaPost\Event\CanadaPostServiceEvents;
use CanadaPost\Model\CanadaPostServiceQuery;
use CanadaPost\Model\CanadaPostService;
use Thelia\Action\BaseAction;
use Thelia\Core\Event\ToggleVisibilityEvent;
use Thelia\Core\Event\UpdatePositionEvent;
use Propel\Runtime\Propel;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Thelia\Core\Event\TheliaEvents;
use \Thelia\Core\Event\TheliaFormEvent;

/**
 * Class CanadaPostServiceAction
 * @package CanadaPost\Action
 * @author TheliaStudio
 */
class CanadaPostServiceAction extends BaseAction implements EventSubscriberInterface
{
    public function create(CanadaPostServiceEvent $event)
    {
        $this->createOrUpdate($event, new CanadaPostService());
    }

    public function update(CanadaPostServiceEvent $event)
    {
        $model = $this->getCanadaPostService($event);

        $this->createOrUpdate($event, $model);
    }

    public function delete(CanadaPostServiceEvent $event)
    {
        $this->getCanadaPostService($event)->delete();
    }

    protected function createOrUpdate(CanadaPostServiceEvent $event, CanadaPostService $model)
    {
        $con = Propel::getConnection(CanadaPostServiceTableMap::DATABASE_NAME);
        $con->beginTransaction();

        try {
            $model->setLocale($event->getLocale());

            if (null !== $id = $event->getId()) {
                $model->setId($id);
            }

            if (null !== $visible = $event->getVisible()) {
                $model->setVisible($visible);
            }

            if (null !== $code = $event->getCode()) {
                $model->setCode($code);
            }

            if (null !== $title = $event->getTitle()) {
                $model->setTitle($title);
            }

            if (null !== $chapo = $event->getChapo()) {
                $model->setChapo($chapo);
            }

            $model->save($con);

            $con->commit();
        } catch (\Exception $e) {
            $con->rollback();

            throw $e;
        }

        $event->setCanadaPostService($model);
    }

    protected function getCanadaPostService(CanadaPostServiceEvent $event)
    {
        $model = CanadaPostServiceQuery::create()->findPk($event->getId());

        if (null === $model) {
            throw new \RuntimeException(sprintf(
                "The 'canada_post_service' id '%d' doesn't exist",
                $event->getId()
            ));
        }

        return $model;
    }

    public function toggleVisibility(ToggleVisibilityEvent $event)
    {
        $this->genericToggleVisibility(new CanadaPostServiceQuery(), $event);
    }

    public function beforeCreateFormBuild(TheliaFormEvent $event)
    {
    }

    public function beforeUpdateFormBuild(TheliaFormEvent $event)
    {
    }

    public function afterCreateFormBuild(TheliaFormEvent $event)
    {
    }

    public function afterUpdateFormBuild(TheliaFormEvent $event)
    {
    }

    /**
     * Returns an array of event names this subscriber wants to listen to.
     *
     * The array keys are event names and the value can be:
     *
     *  * The method name to call (priority defaults to 0)
     *  * An array composed of the method name to call and the priority
     *  * An array of arrays composed of the method names to call and respective
     *    priorities, or 0 if unset
     *
     * For instance:
     *
     *  * array('eventName' => 'methodName')
     *  * array('eventName' => array('methodName', $priority))
     *  * array('eventName' => array(array('methodName1', $priority), array('methodName2'))
     *
     * @return array The event names to listen to
     *
     * @api
     */
    public static function getSubscribedEvents()
    {
        return array(
            CanadaPostServiceEvents::CREATE => array("create", 128),
            CanadaPostServiceEvents::UPDATE => array("update", 128),
            CanadaPostServiceEvents::DELETE => array("delete", 128),
            CanadaPostServiceEvents::TOGGLE_VISIBILITY => array("toggleVisibility", 128),
            TheliaEvents::FORM_BEFORE_BUILD . ".canada_post_service_create" => array("beforeCreateFormBuild", 128),
            TheliaEvents::FORM_BEFORE_BUILD . ".canada_post_service_update" => array("beforeUpdateFormBuild", 128),
            TheliaEvents::FORM_AFTER_BUILD . ".canada_post_service_create" => array("afterCreateFormBuild", 128),
            TheliaEvents::FORM_AFTER_BUILD . ".canada_post_service_update" => array("afterUpdateFormBuild", 128),
        );
    }
}
