<?php
/**
 * This class has been generated by TheliaStudio
 * For more information, see https://github.com/thelia-modules/TheliaStudio
 */

namespace CanadaPost\Controller;

use CanadaPost\Api\GetServices;
use CanadaPost\Controller\Base\CanadaPostServiceController as BaseCanadaPostServiceController;
use CanadaPost\Model\CanadaPostService;
use CanadaPost\Model\CanadaPostServiceQuery;
use Thelia\Core\Security\AccessManager;
use Thelia\Model\LangQuery;
use Thelia\Model\Map\LangTableMap;

/**
 * Class CanadaPostServiceController
 * @package CanadaPost\Controller
 */
class CanadaPostServiceController extends BaseCanadaPostServiceController
{
    public function importAction()
    {
        if (null !== $response = $this->checkAuth($this->resourceCode, $this->getModuleCode(), AccessManager::CREATE)) {
            return $response;
        }


        $locales = [
            "fr-CA" => ["fr_CA", "fr_FR"],
            "en-CA" => ["en_CA", "en_US"],
        ];

        $theliaLocales = LangQuery::create()->select(LangTableMap::LOCALE)->find()->toArray();

        $api = new GetServices();
        foreach ($locales as $locale => $allLocales) {

            $localesToSave = array_intersect($allLocales, $theliaLocales);
            if (0 < count($localesToSave)) {
                $api->setLocale($locale);
                $response = $api->getServices();
                $services = $response->getServices();

                foreach ($services as $service) {

                    $canadaPostService = null;
                    $canadaPostService = CanadaPostServiceQuery::create()->findOneByCode($service['code']);

                    if (null === $canadaPostService) {
                        $canadaPostService = new CanadaPostService();
                        $canadaPostService
                            ->setCode($service['code'])
                            ->setVisible(1);
                    }

                    foreach ($localesToSave as $localeToSave) {
                        $canadaPostService->setLocale($localeToSave);
                        $title = $canadaPostService->getTitle();
                        if (empty($title)) {
                            $canadaPostService->setTitle($service['name']);
                        }
                    }

                    $canadaPostService->save();
                }
            }
        }

        return $this->redirectToListTemplate();
    }
}
