<?php
/**
* This class has been generated by TheliaStudio
* For more information, see https://github.com/thelia-modules/TheliaStudio
*/

namespace CanadaPost\Loop\Base;

use Propel\Runtime\ActiveQuery\Criteria;
use Thelia\Core\Template\Element\BaseLoop;
use Thelia\Core\Template\Element\LoopResult;
use Thelia\Core\Template\Element\LoopResultRow;
use Thelia\Core\Template\Element\PropelSearchLoopInterface;
use Thelia\Core\Template\Loop\Argument\Argument;
use Thelia\Core\Template\Loop\Argument\ArgumentCollection;
use Thelia\Type\BooleanOrBothType;
use CanadaPost\Model\CanadaPostOrderQuery;

/**
 * Class CanadaPostOrder
 * @package CanadaPost\Loop\Base
 * @author TheliaStudio
 */
class CanadaPostOrder extends BaseLoop implements PropelSearchLoopInterface
{

    /**
     * @param LoopResult $loopResult
     *
     * @return LoopResult
     */
    public function parseResults(LoopResult $loopResult)
    {
        /** @var \CanadaPost\Model\CanadaPostOrder $entry */
        foreach ($loopResult->getResultDataCollection() as $entry) {
            $row = new LoopResultRow($entry);

            $row
                ->set("ID", $entry->getId())
                ->set("ADDRESS_ID", $entry->getAddressId())
                ->set("ORDER_ADDRESS_ID", $entry->getOrderAddressId())
                ->set("SERVICE_ID", $entry->getServiceId())
                ->set("OPTIONS", $entry->getOptions())
            ;

            $this->addMoreResults($row, $entry);

            $loopResult->addRow($row);
        }

        return $loopResult;
    }

    /**
     * Definition of loop arguments
     *
     * example :
     *
     * public function getArgDefinitions()
     * {
     *  return new ArgumentCollection(
     *
     *       Argument::createIntListTypeArgument('id'),
     *           new Argument(
     *           'ref',
     *           new TypeCollection(
     *               new Type\AlphaNumStringListType()
     *           )
     *       ),
     *       Argument::createIntListTypeArgument('category'),
     *       Argument::createBooleanTypeArgument('new'),
     *       ...
     *   );
     * }
     *
     * @return \Thelia\Core\Template\Loop\Argument\ArgumentCollection
     */
    protected function getArgDefinitions()
    {
        return new ArgumentCollection(
            Argument::createIntListTypeArgument("id"),
            Argument::createIntListTypeArgument("address_id"),
            Argument::createIntListTypeArgument("order_address_id"),
            Argument::createIntListTypeArgument("service_id"),
            Argument::createAnyTypeArgument("options"),
            Argument::createEnumListTypeArgument(
                "order",
                [
                    "id",
                    "id-reverse",
                    "address_id",
                    "address_id-reverse",
                    "order_address_id",
                    "order_address_id-reverse",
                    "service_id",
                    "service_id-reverse",
                    "options",
                    "options-reverse",
                ],
                "id"
            )
        );
    }

    /**
     * this method returns a Propel ModelCriteria
     *
     * @return \Propel\Runtime\ActiveQuery\ModelCriteria
     */
    public function buildModelCriteria()
    {
        $query = new CanadaPostOrderQuery();

        if (null !== $id = $this->getId()) {
            $query->filterById($id);
        }

        if (null !== $address_id = $this->getAddressId()) {
            $query->filterByAddressId($address_id);
        }

        if (null !== $order_address_id = $this->getOrderAddressId()) {
            $query->filterByOrderAddressId($order_address_id);
        }

        if (null !== $service_id = $this->getServiceId()) {
            $query->filterByServiceId($service_id);
        }

        if (null !== $options = $this->getOptions()) {
            $options = array_map("trim", explode(",", $options));
            $query->filterByOptions($options);
        }

        foreach ($this->getOrder() as $order) {
            switch ($order) {
                case "id":
                    $query->orderById();
                    break;
                case "id-reverse":
                    $query->orderById(Criteria::DESC);
                    break;
                case "address_id":
                    $query->orderByAddressId();
                    break;
                case "address_id-reverse":
                    $query->orderByAddressId(Criteria::DESC);
                    break;
                case "order_address_id":
                    $query->orderByOrderAddressId();
                    break;
                case "order_address_id-reverse":
                    $query->orderByOrderAddressId(Criteria::DESC);
                    break;
                case "service_id":
                    $query->orderByServiceId();
                    break;
                case "service_id-reverse":
                    $query->orderByServiceId(Criteria::DESC);
                    break;
                case "options":
                    $query->orderByOptions();
                    break;
                case "options-reverse":
                    $query->orderByOptions(Criteria::DESC);
                    break;
            }
        }

        return $query;
    }

    protected function addMoreResults(LoopResultRow $row, $entryObject)
    {
    }
}
